<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 4.6: Static Variables</title>
<link href="sx7e.html" rev=precedes>
<link href="sx7g.html" rel=precedes>
<link href="sx7.html" rev=subdocument>
</head>
<body>
<H2>section 4.6: Static Variables</H2>

page 83
<p>Deep sentence:
<blockquote>The <TT>static</TT> declaration,
applied to an external variable or function,
limits the scope of that object
to the rest of the source file being compiled.
External <TT>static</TT> thus provides a way to hide names like 
<TT>buf</TT> and <TT>bufp</TT> in the
<TT>getch</TT>-<TT>ungetch</TT> combination,
which must be external so they can be shared,
yet which should not be visible
to users of <TT>getch</TT> and <TT>ungetch</TT>.
</blockquote>So we can have three kinds of declarations:
local to one function,
restricted to one source file,
or global across potentially many source files.
We can imagine other possibilities,
but these three cover most needs.
</p><p>Notice that the <TT>static</TT> keyword does two completely different things.
Applied to a local variable
(one inside of a function),
it modifies the lifetime (``duration'') of the variable
so that it persists for as long as the program does,
and does not disappear between invocations of the function.
Applied to a variable outside of a function
(or to a function)
<TT>static</TT> limits the scope to the current file.
</p><p>To summarize the scope of external and <TT>static</TT> functions and variables:
when a function or global variable is defined without <TT>static</TT>,
its scope is <em>potentially</em> the entire program,
although any file which wishes to use it will generally need an 
<TT>extern</TT> declaration.
A definition with <TT>static</TT> limits the scope
by <em>prohibiting</em> other files 
from accessing a variable or function;
even if they try to use an <TT>extern</TT> declaration,
they'll get errors about ``undefined externals.''
</p><p>The rules for declaring and defining functions and global variables,
and using the <TT>extern</TT> and <TT>static</TT> keywords,
are admittedly complicated and somewhat confusing.
You don't need to memorize all of the rules right away:
just use simple declarations and definitions at first,
and as you find yourself needing some of the more complicated 
possibilities such as <TT>static</TT> variables,
the rules will begin to make more sense.
</p><hr>
<p>
Read sequentially:
<a href="sx7e.html" rev=precedes>prev</a>
<a href="sx7g.html" rel=precedes>next</a>
<a href="sx7.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
